// --- [ main.c ] -------------------------------------------------------------
//
//       tab = 3 - 13.03.2012
//
//       Programmrumpf fr den Multimaster
//       ohne Funktion ...

#define EXTERN
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>

#include "global.h"
#include "TWI_Multi_Master.h"

#define TRUE   1
#define FALSE  0

#define SLAVE_1_ADR  0x40
#define SLAVE_2_ADR  0x42

enum jobs {RX, TX, TRX};

// --- public - Variablen -----------------------------------------------------


// --- Prototypen -------------------------------------------------------------

uint8_t sonst_noch_was_zu_tun(void);

// ----------------------------------------------------------------------------

uint8_t sonst_noch_was_zu_tun(void)
{
   return(1);
}

// ----------------------------------------------------------------------------
int main(void)
{

   uint8_t tx_buffer[20];                   // In TWI_Master.h die Gre des Arrays (TWI_BUF_SIZE) prfen
   uint8_t rx_buffer[20];
   uint8_t rx_cnt, tx_cnt;
   uint8_t e, r;

   uint8_t job = 0;

   TWI_MM_Init();                            // Die TWI-Schnittstelle initialisieren
   asm volatile ("sei");                     // Interrupts freigeben

   DDRB  = (1<<PB0 | 1<<PB1);
   PORTB = (1<<PB0 | 1<<PB1);


   while(1)
   {
      if((rx_cnt = TWI_SLA_Rx_Cnt()))        // Wenn der Slave Daten empfangen hat
      {

         PINB = (1<<PB0);
         TWI_SLA_Get_Data(rx_buffer);        // die Daten abholen

         /*
         Die Daten verarbeiten und zum Testen wieder in den TX-Buffer stellen
         */

         TWI_SLA_Put_Data(rx_buffer, rx_cnt);    // die empfangenen Daten in den Sendepuffer stellen

         if (rx_buffer[1] == 1)                 // buffer[1] bestimmt was zu tun ist
         {
            tx_buffer[0] = SLAVE_1_ADR;
            tx_buffer[1] = 1;
            tx_buffer[2] = 2;
            tx_cnt = 3;
            job = (1<<TX);
         }
         else if (rx_buffer[1] == 2)
         {
            tx_buffer[0] = SLAVE_2_ADR;
            tx_cnt = 3;
            job = (1<<RX);
         }
      }

      if (job)                               // wenn ein Job fr den Master ansteht
      {
         if (job & (1<<TX))
         {
            r = 5;                           // 5 Versuche starten
            while(r--)
            {
               if((e = TWI_MM_Write(tx_buffer, tx_cnt)))
                  {
                  job &= ~(1<<TX);
                  break;
                  }
               if (r == 0)
               {
                  /*   Fehlerbehandlung */
               }
            }
         }

         else if (job & (1<<RX))
         {
            r = 5;                           // 5 Versuche starten
            while(r--)
            {
               if((e = TWI_MM_Read(rx_buffer, rx_cnt)))
                  {
                  job &= ~(1<<RX);
                  break;
                  }
               if (r == 0)
               {
                  /*   Fehlerbehandlung */
               }
            }
         }
      }

      if (sonst_noch_was_zu_tun())
      {

      }
   }
}

// --- [ eof ] ----------------------------------------------------------------
